/*******************************************************************************
+
+  LEDA  2.1.1                                                 11-15-1991
+
+
+  global.c
+
+
+  Copyright (c) 1991  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 6600 Saarbruecken, FRG     
+  All rights reserved.
+ 
*******************************************************************************/



extern double       x_draw_xmax;
extern double       x_draw_xmin;
extern double       x_draw_ymax;
extern double       x_draw_ymin;
extern double       x_draw_scale;
extern int          x_draw_grid_mode; 
extern int          x_draw_depth; 
extern int          x_draw_line_width; 
extern int          x_draw_node_width; 
extern bool         x_draw_screen_flush;
extern line_style   x_draw_line_style; 
extern text_mode    x_draw_text_mode; 
extern drawing_mode x_draw_drawing_mode;

extern "C" 
{ 
  void x_draw_cursor();
  void x_draw_init_window(int,int,int,int,const char*);
  void x_draw_init(double,double,double,int);
  void x_draw_set_frame_label(char*);
  void x_draw_reset_frame_label();
  void x_draw_set_redraw(redraw_func_ptr);
  int  x_draw_set_font(char*);
  int  x_draw_set_line_style(int);
  int  x_draw_set_line_width(int);
  int  x_draw_set_node_width(int);
  int  x_draw_set_text_mode(int);
  int  x_draw_set_mode(int);
  void x_draw_clear(int);
  void x_draw_coord_system(int);
  void x_show_window();
  void x_draw_end();
  void x_draw_line(double,double,double,double,int);
  void x_draw_ellipse(double,double,double,double,int);
  void x_draw_filled_ellipse(double,double,double,double,int);
  void x_draw_circle(double,double,double,int);
  void x_draw_filled_circle(double,double,double,int);
  void x_draw_point(double,double,int);
  void x_draw_node(double,double,int);
  void x_draw_filled_node(double,double,int);
  void x_draw_text_node(double,double,char*,int);
  void x_draw_int_node(double,double,int,int);
  void x_draw_polygon(int,double*,double*,int);
  void x_draw_filled_polygon(int,double*,double*,int);
  void x_draw_rectangle(double,double,double,double,int);
  void x_draw_filled_rectangle(double,double,double,double,int);
  void x_draw_copy_rect(double,double,double,double,double,double);

  //void x_draw_copy(double,double,double,double,int);
  //void x_draw_paste(int,double,double);
  //void x_draw_cut(double,double,double,double,int);
  //void x_draw_clear_buf(int);
  //void x_draw_move_rect(double,double,double,double,double,double);

  void x_draw_message(int,char*,int);
  void x_draw_message_panel(int,char**);
  void x_draw_text(double,double,char*,int);
  void x_draw_ctext(double,double,char*,int);
  void x_draw_pix(double,double,int);
  void x_draw_plot_xy(double,double,draw_func_ptr,int);
  void x_draw_plot_yx(double,double,draw_func_ptr,int);
  int  x_read_mouse_action(mouse_action_func_ptr,double,double,double*,double*);
  int  x_read_mouse(int,double,double,double*,double*);

  int  x_draw_xpix(double);
  int  x_draw_ypix(double);
  void x_draw_flush();
  int  x_draw_screen_width();
  int  x_draw_screen_height();

  int   x_draw_confirm(char*);
  int   x_draw_acknowledge(char*);
  int   x_draw_read_panel(char*,int,char**,int);
  char* x_draw_read_text_panel(char*,char*,int,char**);

  void* x_draw_panel_create();
  void  x_draw_panel_text_item(void*,char*);
  void  x_draw_panel_slider_item(void*,char*,int*,int,int);
  void  x_draw_panel_choice_item(void*,char*,int*,int,char**,int,int);
  void  x_draw_panel_int_item(void*,char*,int*);
  void  x_draw_panel_float_item(void*,char*,double*);
  void  x_draw_panel_string_item(void*,char*,char*);
  void  x_draw_panel_string_menu_item(void*,char*,char*,char*,int,char**);
  void  x_draw_panel_button(void*,char*);
  void  x_draw_panel_button_line(void*,int,char**);
  void  x_draw_panel_label(void*,char*);
  void  x_draw_panel_destroy(void*);
  int   x_draw_panel_open(void*);

};
